import utils
from sklearn import svm
from sklearn.externals import joblib
import numpy as np
from collections import Counter

porc_entr = 0.90 # training percentage

temp_path = utils.get_config_value('Folders', 'DataFolder')

confusion = np.zeros((9, 8, 8))
svm_pred = np.zeros((9, 97))

for lbp in range(1, 9):
    XB = joblib.load(temp_path+'LBP_8_'+str(lbp)+'/XB.pkl')
    YB = joblib.load(temp_path+'LBP_8_'+str(lbp)+'/YB.pkl')
    XTB = joblib.load(temp_path+'LBP_8_'+str(lbp)+'/XTB.pkl')
    YTB = joblib.load(temp_path+'LBP_8_'+str(lbp)+'/YTB.pkl')

    # Train classifier
    params = {}
    params['kernel'] = 'poly'
    params['degree'] = 6
    params['C'] = 1.0
    params['coef0'] = 100.0
    params['gamma'] = 0.001
    params['class_weight'] = 'balanced'
    params['decision_function_shape'] = 'ovr'

    clf = svm.SVC(**params)
    clf.fit(XB, YB)

    # Test
    svm_pr = clf.predict(XTB)
    for i in range(len(XTB)):
        svm_pred[lbp][i] = svm_pr[i]

    print(svm_pr)

prediction = np.zeros(len(YTB))
pred = np.zeros(8)

for i in range(len(YTB)):
    for j in range(1, len(svm_pred)):
        pred[j-1] = svm_pred[j][i]

    count = Counter(pred)
    prediction[i] = count.most_common()[0][0]


errors_svm = sum([prediction[i] != YTB[i] for i in range(len(YTB))])
print("Error SVM: {0:.2f}%".format(float(errors_svm) / float(len(YTB))*100.0))

confusion = np.zeros((8, 8))
for j in range(len(prediction)):
    confusion[YTB[j],prediction[j]] = confusion[YTB[j],prediction[j]]+1

print("Confusion Matrix:")
print(confusion)



print("Process finished.")
