# -*- coding: utf-8 -*-
"""
Created on Tue Dec 29 23:24:35 2015

@author: Miguel Canteras
"""

import libs.bottle as bottle
from libs.bottle import route, request, response, abort
import os
import utils
import requests
from sklearn.externals import joblib
from sklearn import svm
import json

# Load SVM at startup
clf = {}
clf[1] = joblib.load('./model_svm/1/au_svm.pkl')
clf[2] = joblib.load('./model_svm/2/au_svm.pkl')
clf[4] = joblib.load('./model_svm/4/au_svm.pkl')
clf[5] = joblib.load('./model_svm/5/au_svm.pkl')
clf[6] = joblib.load('./model_svm/6/au_svm.pkl')
clf[7] = joblib.load('./model_svm/7/au_svm.pkl')
clf[9] = joblib.load('./model_svm/9/au_svm.pkl')
clf[12] = joblib.load('./model_svm/12/au_svm.pkl')
clf[15] = joblib.load('./model_svm/15/au_svm.pkl')
clf[17] = joblib.load('./model_svm/17/au_svm.pkl')
clf[20] = joblib.load('./model_svm/20/au_svm.pkl')
clf[25] = joblib.load('./model_svm/25/au_svm.pkl')
clf[27] = joblib.load('./model_svm/27/au_svm.pkl')

# Enable CORS calls
# Based on http://paulscott.co.za/blog/cors-in-python-bottle-framework/
def enable_cors(fn):
    def _enable_cors(*args, **kwargs):
        # set CORS headers
        response.headers['Access-Control-Allow-Origin'] = '*'
        response.headers['Access-Control-Allow-Methods'] = 'GET, POST, PUT, OPTIONS'
        response.headers['Access-Control-Allow-Headers'] = 'Origin, Accept, Content-Type, X-Requested-With, X-CSRF-Token'

        if request.method != 'OPTIONS':
            # actual request; reply with the actual response
            return fn(*args, **kwargs)

    return _enable_cors

@route('/classification/v1/aus/activation', method=['POST', 'OPTIONS'])
@enable_cors
def classify():

    current_feature = json.loads(request.forms.get('feature'))

    # ==============
    # CLASSIFICATION
    # ==============

    cl = {}

    for i in [1,2,4,5,6,7,9,12,15,17,20,25,27]:

        svm_pred = clf[i].predict(current_feature)

        cl[i] = round(svm_pred)

    result = dict([('Classification', cl)])
    
    # ===========
    # RETURN DATA
    # ===========
    response.content_type = 'application/json'
    return result


# Run bottle internal test server when invoked directly ie: non-uxsgi mode
if __name__ == '__main__':
    bottle.run(host='0.0.0.0', port=4042, debug=True, reloader=True)
# Run bottle in application mode. Required in order to get the application working with uWSGI!
else:
    app = application = bottle.default_app()
    