import os
import utils
from sklearn.externals import joblib
from sklearn import svm
from sklearn.cross_validation import StratifiedShuffleSplit
import numpy as np

porc_entr = 0.9 # training percentage

temp_path = utils.get_config_value('Folders', 'TempFolder')
X = joblib.load(temp_path+'X.pkl')
Y = joblib.load(temp_path+'Y.pkl')

X = np.array(X)
Y = np.array(Y)

tot = 0
YC = np.zeros(len(Y))

for i in [1,2,4,5,6,7,9,12,15,17,20,25,27]:
#for i in [1,2,4,5,6,7]:
#for i in [12,15,17,20,25,27]:
    for idx, y in enumerate(Y):
        if i in y:
            YC[idx] = 1
        else:
            YC[idx] = 0

    n1 = 0
    n2 = 1024
    #if i >= 1 and i <= 7:
    #    n2 = 512
    #if i >= 9 and i <= 25:
    #    n1 = 512

    XC = X[0:len(X),n1:n2]

    # Training samples
    train_samples = int(len(XC)*porc_entr)
    E = XC[:train_samples]
    C_E=YC[:train_samples]

    # Testing samples
    test_samples = len(XC) - train_samples
    T = XC[-test_samples:]
    C_T=YC[-test_samples:]

    # Train classifier
    params = {}

    #params['kernel'] = 'linear'
    #params['C'] = 100000.0

    #params['kernel'] = 'rbf'
    #params['C'] = 2.0
    #params['gamma'] =10

    params['kernel'] = 'poly'
    params['degree'] = 6
    params['C'] = 1.0
    params['coef0'] = 100.0
    params['gamma'] = 0.001
    params['class_weight'] = 'balanced'

    clf = svm.SVC(**params)
    clf.fit(E, C_E)

    # Test
    svm_pred = clf.predict(T)
    errors_svm = sum([svm_pred[j] != C_T[j] for j in range(len(T))])
    r = float(errors_svm) / float(len(C_T))*100.0
    tot +=r

    # Persist model
    temp_path = utils.get_config_value('Folders', 'TempFolder')
    if not os.path.exists(temp_path+ str(i)):
        os.makedirs(temp_path+ str(i))

    joblib.dump(clf, temp_path+ str(i)+'/au_svm.pkl')

    print("\n/////////////////////////\n")

    print("AU {0:d} - Error SVM: {1:.2f}\t".format(i, r))

    print("Training elements: {0:d}".format(len(C_E)))
    print("Test elements: {0:d}".format(len(C_T)))

    dispersion = np.zeros((2))
    for j in range(len(C_E)):
        dispersion[C_E[j]] = dispersion[C_E[j]]+1

    print("Training elements by class:")
    print(dispersion)

    dispersion = np.zeros((2))
    for j in range(len(C_T)):
        dispersion[C_T[j]] = dispersion[C_T[j]]+1

    print("Test elements by class:")
    print(dispersion)

    confusion = np.zeros((2, 2))
    for j in range(len(svm_pred)):
        confusion[C_T[j],svm_pred[j]] = confusion[C_T[j],svm_pred[j]]+1

    print("Confusion Matrix:")
    print(confusion)

    for i in range(2):
        for j in range(2):
            if dispersion[i] == 0:
                confusion[i,j] = 0
            else:
                confusion[i,j] = float(confusion[i,j]) * 100.0 / float(dispersion[i])

    print("Confusion Matrix Percentage:")
    print(confusion)

print("Error medio: {0:.2f}\t".format(tot/13))

print("Process finished.")
