import utils
from sklearn import svm
from sklearn.externals import joblib
import numpy as np
from sklearn import preprocessing

porc_entr = 0.90 # training percentage

temp_path = utils.get_config_value('Folders', 'TempFolder')
X = joblib.load(temp_path+'X.pkl')
Y = joblib.load(temp_path+'Y.pkl')

# Normalize dat
# X = preprocessing.scale(X)
# m = X.mean(axis=0)
# s = X.std(axis=0)

max_n0= round(327 * porc_entr)
max_n1= round(45 * porc_entr * 3)
max_n2= round(18 * porc_entr * 3)
max_n3= round(59 * porc_entr * 3)
max_n4= round(25 * porc_entr * 3)
max_n5= round(69 * porc_entr * 3)
max_n6= round(28 * porc_entr * 3)
max_n7= round(83 * porc_entr * 3)


n0= 0
n1= 0
n2= 0
n3= 0
n4= 0
n5= 0
n6= 0
n7= 0
nt=0

XB = []
YB = []
XTB = []
YTB = []

#for j in range(4):
for i in range(len(X)):
    # if Y[i] == 0:
    #    if n0 < max_n0:
    #        n0 +=1
    #        nt +=1
    #        XB.append(X[i])
    #        YB.append(Y[i])
    #    else:
    #        XTB.append(X[i])
    #        YTB.append(Y[i])
    if Y[i] == 1:
        if n1 < max_n1:
            n1 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 2:
        if n2 < max_n2:
            n2 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 3:
        if n3 < max_n3:
            n3 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 4:
        if n4 < max_n4:
            n4 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 5:
        if n5 < max_n5:
            n5 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 6:
        if n6 < max_n6:
            n6 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])
    if Y[i] == 7:
        if n7 < max_n7:
            n7 +=1
            nt +=1
            XB.append(X[i])
            YB.append(Y[i])
        else:
            XTB.append(X[i])
            YTB.append(Y[i])


# Train classifier
params = {}
params['probability'] = True

# params['kernel'] = 'linear'
# params['C'] = 1.0

params['kernel'] = 'poly'
params['degree'] = 6
params['C'] = 1.0
params['coef0'] = 100.0
params['gamma'] = 0.001
params['class_weight'] = 'balanced'
params['decision_function_shape'] = 'ovr'

#params['kernel'] = 'rbf'
#params['gamma'] = 10
#params['C'] = 1.0

temp_path = utils.get_config_value('Folders', 'TempFolder')
joblib.dump(XB, temp_path+'XB.pkl')
joblib.dump(YB, temp_path+'YB.pkl')
joblib.dump(XTB, temp_path+'XTB.pkl')
joblib.dump(YTB, temp_path+'YTB.pkl')


clf = svm.SVC(**params)
clf.fit(XB, YB)

# Persist model
joblib.dump(clf, temp_path+'emotions_svm.pkl')

# Test
svm_pred = clf.predict(XTB)

errors_svm = sum([svm_pred[i] != YTB[i] for i in range(len(XTB))])
print("Error SVM: {0:.2f}%".format(float(errors_svm) / float(len(XTB))*100.0))

print("Training elements: {0:d}".format(len(YB)))
print("Test elements: {0:d}".format(len(YTB)))

dispersion = np.zeros((8))
for j in range(len(YB)):
    dispersion[YB[j]] = dispersion[YB[j]]+1

print("Training elements by emotion:")
print(dispersion)

dispersion = np.zeros((8))
for j in range(len(YTB)):
    dispersion[YTB[j]] = dispersion[YTB[j]]+1

print("Test elements by emotion:")
print(dispersion)

confusion = np.zeros((8, 8))
for j in range(len(svm_pred)):
    confusion[YTB[j],svm_pred[j]] = confusion[YTB[j],svm_pred[j]]+1

print("Confusion Matrix:")
print(confusion)

for i in range(8):
    for j in range(8):
        if dispersion[i] == 0:
            confusion[i,j] = 0
        else:
            confusion[i,j] = float(confusion[i,j]) * 100.0 / float(dispersion[i])

print("Confusion Matrix Percentage:")
print(confusion)

print("Process finished.")
